<?php

require_once RootDir.'etc/Devices.php';
require_once 'classes/PHPMailer/class.phpmailer.php';

?>

<?php 
if ( isset( $_GET['device'] ) && isset( $VoIPDevices[$_GET['device']] ) ){

  $ShippingFees = 0;
   if ( 
        strtolower($Customer->customer_info['Country']) == 'switzerland'
     || strtolower($Customer->customer_info['Country']) == 'suisse' 
     || strtolower($Customer->customer_info['Country']) == 'schweiz' 
     || strtolower($Customer->customer_info['Country']) == 'swiss' 
    ) { 
      $ShippingFees = $DeviceShippingFees['SWITZERLAND'][$Customer->customer_info['Currency']];
    } else {
      $ShippingFees = $DeviceShippingFees['INTERNATIONAL'][$Customer->customer_info['Currency']];
    }


  $TotalAmount = $VoIPDevices[$_GET['device']]['PRICE'][$Customer->customer_info['Currency']] + $ShippingFees;

  $AvailableFunds = $Customer->customer_info['AvailableFunds'];

  if ( $TotalAmount < $AvailableFunds ){
    if ( $Customer->charge( $TotalAmount, $VoIPDevices[$_GET['device']]['NAME'], "Order ". $_GET['device'] ) ){

      $mail = new PHPMailer;
      $mail->CharSet = 'UTF-8';

      $mail->From = 'contracts@switzernet.com';
      $mail->FromName = 'Switzernet';
      $Subject = l('Device order confirmation');

      
      $CustomerEmail = FALSE;
      if ( isset( $Customer->customer_info['Email'] ) && $Customer->customer_info['Email'] != '' ){
        $CustomerEmail = TRUE;        
        $mail->addAddress($Customer->customer_info['Email']);     // Add a recipient
      } else {
        $Subject = '[customer email address no found] '.l('Device order confirmation');
        $mail->addAddress( 'contracts@switzernet.com');     // Add a recipient
      }

      //$mail->addAddress($Customer->customer_info['Email'], 'Nicolas Bondier');     // Add a recipient
      $mail->AddBCC('contracts@switzernet.com');               // Name is optional
      $mail->addReplyTo('contracts@switzernet.com', 'Information');

      $body = '';
      $body .= l("Dear")." ".$Customer->customer_info['Firstname']." ".$Customer->customer_info['Lastname'].",\n\n";
      $body .= l("This is to inform you that your order has been completed and you will receive your device soon").".\n\n";
      //$body .= "\n\n";

      $body .= l("Your order:")."\n";
      $body .= l("Device name:")." ".$VoIPDevices[$_GET['device']]['NAME']."\n";
      $body .= l("Device price:")." ".$VoIPDevices[$_GET['device']]['PRICE'][$Customer->customer_info['Currency']]." ".$Customer->customer_info['Currency']."\n";
      $body .= l("Shipping fees:")." ".number_format($ShippingFees,2)." ".$Customer->customer_info['Currency']."\n";
      $body .= l("Total order:")." ".$TotalAmount." ".$Customer->customer_info['Currency']."\n\n";

      //$body .= print_r($_POST, TRUE);


      $body .= l("Your shipping information:")."\n";

      $maxl = max(array_map('strlen', $_POST['ShippingAddress']));

      foreach ($_POST['ShippingAddress'] as $key => $value) {
        $l = strlen($key);
        $body .= $key;
        for ($i=$l; $i <= $maxl; $i++) { 
          $body .= " ";
        }
        $body .= ": ".$value."\n";
      }

      if ( isset( $_POST['DeviceConfiguration'] ) && isset( $_POST['DeviceConfiguration']['AccountID'] ) ){

        if ( in_array($_POST['DeviceConfiguration']['AccountID'], $Customer->customer_info['AccountsList'] ) ){
          $body .= "\n".l("The device will be pre-configured with your account"). " " .$_POST['DeviceConfiguration']['AccountID']."\n";
        }

      }
      

      $body .= "\n".l("Best regards,")."\n";
      $body .= l("Switzernet")."\n\n";
      $mail->Subject = '';
      $mail->Body    = $body;
      $mail->Subject = $Subject;



      if(!$mail->send()) {
        echo '<div class="alert-message">';
        echo l('An error occured during confirmation email sending. Please contact website administrator');
        echo '</div>';
      } else {
        echo '<div class="ok-message">';
        echo l('Your order has been completed and your balance has been charged.');
        //print_r($Customer);
        if ( $CustomerEmail ){
          echo ' '.l('You will receive a confirmation email on your email address').' <b>'.$Customer->customer_info['Email'].'</b>.';
        }
        echo ' '.l('Thank you for your purchase.');
        echo '</div>';
        echo '
          <script type="text/javascript">
            var newbutton="<button type=\"button\" id=\"finish-button\" class=\"pure-button view-button\" onclick=\"window.location=\'#/shop\'; window.location.reload()\" >'.l('Finish').'</button>";
            $( "#return-to-shop" ).replaceWith( newbutton );
            $( "#buy-button" ).remove();
          </script>';
      }

      } else {
      echo '<div class="alert-message">';
      echo l('An error occured. Please try again later or contact website administrator');
      echo '</div>';
    }
  } else {
    echo '<div class="alert-message">';
    echo l("The available founds on your account (").number_format($Customer->customer_info['AvailableFunds'],2)." ".$Customer->customer_info['Currency'].l(") are not suficient to pay your order (Price: ").number_format($TotalAmount,2)." ".$Customer->customer_info['Currency'].". ".l("Please recharge your account from")." <b><a href=\"#/billing\" onclick=\"load_view('billing');\">".l("Billing")."</a></b> ".l("page first.");
    echo '</div>';
  }
} else{
    echo '<div class="alert-message">';
    echo l("This device is not available.");
    echo '</div>';
}
?>