<?php

/**
* 
*/

class Account
{
  public  $account_info;
  public  $porta_billing_account = FALSE;
  private $LocalMysqli;
  private $MasterMysqli;
  private $ServiceCustomer;
  private $ServiceAccount;

  function __construct() {
    $this->web_db_connect();
    $this->master_db_connect();
    $this->soap_connect();
  }

  function __wakeup(){
    $this->web_db_connect();
    $this->master_db_connect();
    $this->soap_connect();
  }

  public function _close(){
    $this->LocalMysqli->close();
    $this->MasterMysqli->close();
  }

  function __destruct(){
    $this->LocalMysqli->close();
    $this->MasterMysqli->close();
  }

  public function load_account_info(){

    if ( $this->porta_billing_account == TRUE ){
      $param = '';
      if ( isset( $this->account_info['ID'] ) ){
        $param = $this->account_info['ID'];
        $sql = "SELECT *,NOW() as CurrentTime FROM Accounts WHERE id = ?";
        $stmt = $this->MasterMysqli->prepare($sql);
        $state = $stmt->bind_param( "s", $param );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        if ( $res['i_account'] > 0 ){
          $this->account_info = $res;
          $this->account_info['ID'] = $res['id'];
        } else {
          return false;
        }
      } elseif( isset( $this->account_info['i_account'] ) ){
        $param = $this->account_info['i_account'];
        $sql = "SELECT *,NOW() as CurrentTime FROM Accounts WHERE i_account = ?";
        $stmt = $this->MasterMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $param );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        if ( $res['i_account'] > 0 ){
          $this->account_info = $res;
          $this->account_info['ID'] = $res['id'];
        } else {
          return false;
        }
      }

      error_log("SETTING DEFAULT VALUES");
      $this->account_info['CurrentSubscriptionType'] = 0;
      $this->account_info['CurrentSubscriptionExpirationDate'] = '0000-00-00 00:00:00';
      $this->account_info['SubscriptionAutoRenewal'] = '0';
      $this->account_info['IsPrepaidPrivate'] = false;
      $this->get_subscription_plan();
      $this->account_info['Active'] = 1;
    } else {
      $param = '';
      if ( isset( $this->account_info['ID'] ) ){
        $param = $this->account_info['ID'];
        $sql = "SELECT *, NOW() as CurrentTime FROM Web_Subscription_Selected_Numbers WHERE h323_id = ?";
        $stmt = $this->LocalMysqli->prepare($sql);
        $state = $stmt->bind_param( "s", $param );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        if ( $res['i_web_subscription_reserved_number'] > 0 ){
          $this->account_info = $res;
          $this->account_info['CurrentSubscriptionType'] = 0;
          $this->account_info['CurrentSubscriptionExpirationDate'] = '0000-00-00 00:00:00';
          $this->account_info['SubscriptionAutoRenewal'] = '0';
          $this->account_info['IsPrepaidPrivate'] = false;
          $this->account_info['Active'] = 0;
          $this->account_info['ID'] = $res['h323_id'];
        } else {
          return false;
        }
      } elseif( isset( $this->account_info['i_web_subscription_reserved_number'] ) ){
        $param = $this->account_info['i_web_subscription_reserved_number'];
        $sql = "SELECT *, NOW() as CurrentTime FROM Web_Subscription_Selected_Numbers WHERE i_web_subscription_reserved_number = ?";
        $stmt = $this->LocalMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $param );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        if ( $res['i_web_subscription_reserved_number'] > 0 ){
          $this->account_info = $res;
          $this->account_info['CurrentSubscriptionType'] = 0;
          $this->account_info['CurrentSubscriptionExpirationDate'] = '0000-00-00 00:00:00';
          $this->account_info['SubscriptionAutoRenewal'] = '0';
          $this->account_info['IsPrepaidPrivate'] = false;
          $this->account_info['Active'] = 0;
          $this->account_info['ID'] = $res['h323_id'];
        } else {
          return false;
        }
      }
    }
    return TRUE;
  }

  public function set_i_account($i_account){
    $this->account_info['i_account'] = $i_account;

  }

  public function set_account_id($id){
    $this->account_info['ID'] = $id;
  }

  public function update_subscription_on_expiration(){
    /*
    if ( strtotime( $this->account_info['CurrentTime'] ) > strtotime($this->account_info['CurrentSubscriptionExpirationDate']) ){
      if ( $this->account_info['CurrentSubscriptionType'] != $this->account_info['NextSubscriptionType'] ){
        try {    
          $sql = "UPDATE account_data SET CurrentSubscriptionType = NextSubscriptionType WHERE i_account = ?";
          $stmt = $this->LocalMysqli->prepare($sql);
          $state = $stmt->bind_param( "i", $this->account_info['i_account'] );
          $stmt->execute();
          $stmt->close();
          $this->load_account_info();
          return true;
        } catch (mysqli_sql_exception $e) {
          throw new Account_Exception("MySQL error ".$this->LocalMysqli->error." <br> Query:<br> $sql", $this->LocalMysqli->errno);
          return false;
        }
      }
    }
    */
  }

  public function get_subscription_plan(){
    include dirname(__FILE__) . '/../etc/' . "SubscriptionPlans.php";
    /*
    try {
      $GetAccountSubscriptionsRequest = array( 'i_account' => $this->account_info['i_account'] );
      $GetAccountSubscriptionsResponse = $this->ServiceAccount->get_subscriptions( $GetAccountSubscriptionsRequest );
      $subscriptions = $GetAccountSubscriptionsResponse->subscriptions;
    } catch (SoapFault $fault) {
      throw new Account_Exception("Soap error :".$fault);
      return false;
    }

    foreach ($subscriptions as $subscription) {
      if ( $subscription->i_subscription == $PB_Prepaid_Subscription_Plans[$this->account_info['iso_4217']] ){
        if ( $subscription->is_finished == 'N' ){
          $this->account_info['CurrentSubscriptionExpirationDate'] = date('Y-m-d H:i:s', strtotime( $subscription->finish_date ));
          break;
        }
      }
    }
*/
    # IS PRIVATE PREPAID

    if ( isset( $PB_Private_Prepaid_Products[ $this->account_info['iso_4217'] ] ) && $this->account_info['i_product'] == $PB_Private_Prepaid_Products[ $this->account_info['iso_4217'] ] ){
      $this->account_info['IsPrepaidPrivate'] = true;
    } else {
      $this->account_info['IsPrepaidPrivate'] = false;
    }

    # GET EXPIRATION DATE

    if (  isset( $this->account_info['expiration_date'] ) && $this->account_info['expiration_date'] != '' ){
      $this->account_info['CurrentSubscriptionExpirationDate'] = $this->account_info['expiration_date'];
    } else {
      $this->account_info['CurrentSubscriptionExpirationDate'] = NULL;
    }

    # GET KNOWN SELECTED SUBSCRIPTION ID

    try {
      $GetAccountCustomFieldsValuesRequest = array(
        'i_account' => $this->account_info['i_account']
      );
      $GetAccountCustomFieldsValuesResponse = $this->ServiceAccount->get_custom_fields_values($GetAccountCustomFieldsValuesRequest);
      //error_log(print_r($GetAccountCustomFieldsValuesResponse, TRUE));
    } catch (SoapFault $fault) {
      throw new Account_Exception("Soap error :".$fault);
      return false;
    }

    $custom_fields_values = $GetAccountCustomFieldsValuesResponse->custom_fields_values;
    foreach ($custom_fields_values as $custom_fields_value) {
      if ( $custom_fields_value->name == 'Auto renewal subscription plan' ){
        $this->account_info['SubscriptionAutoRenewal'] = $custom_fields_value->db_value;
      }
      if ( $custom_fields_value->name == 'Prepaid subscription plan' ){
        $this->account_info['CurrentSubscriptionType'] = $custom_fields_value->db_value;
      }
    }
    //  $this->account_info['CurrentSubscriptionType'] = 0;
    //  $this->account_info['CurrentSubscriptionExpirationDate'] = '0000-00-00 00:00:00';
    //  $this->account_info['SubscriptionAutoRenewal'] = '0';
  }



  public function update_subscription_plan( $i_subscription_plan, $update_expiration_date = TRUE ){
    include dirname(__FILE__) . '/../etc/' . "SubscriptionPlans.php";

    if ( !isset( $SubscriptionPlans[$i_subscription_plan] ) ){
      return FALSE;
    }

    if ( $update_expiration_date !== TRUE && $update_expiration_date !== FALSE ){
      return FALSE;
    }


    if ( $update_expiration_date ){

      if ( $i_subscription_plan > 0 ){
        //error_log(print_r($this, TRUE));

        /*
        try {
          $GetAccountSubscriptionsRequest = array( 'i_account' => $this->account_info['i_account'] );
          $GetAccountSubscriptionsResponse = $this->ServiceAccount->get_subscriptions( $GetAccountSubscriptionsRequest );
          $subscriptions = $GetAccountSubscriptionsResponse->subscriptions;
        } catch (SoapFault $fault) {
          throw new Account_Exception("Soap error :".$fault);
          return FALSE;
        }
        $updated = FALSE;
        $subscription_done = FALSE;
        $found = FALSE;
        foreach ($subscriptions as $subscription) {
          if ( $subscription->i_subscription == $PB_Prepaid_Subscription_Plans[$this->account_info['iso_4217']] ){
            if ( $subscription->is_finished == 'N' ){
              if ( $subscription->finish_date == '' || !isset($subscription->finish_date) || $subscription->finish_date == NULL ){
                $subscription->finish_date  = date('Y-m-d');
              }
              $finish_date = date( 'Y-m-d' , max( strtotime( date('Y-m-d') ) , strtotime( $subscription->finish_date ) ) ) ;
              $subscription->finish_date = date('Y-m-d', strtotime('+'.$SubscriptionPlans[$i_subscription_plan]['RenewalPeriodMonths'].' months', strtotime( $finish_date ) ) );
              
              unset( $subscription->start_date );
              
              $UpdateAccountSubscriptionRequest =  array( 
                 'i_account' => $this->account_info['i_account'],
                 'i_account_subscription' => $subscription->i_account_subscription,
                 'subscription_info' => $subscription
              );
              try {
                $AddUpdateAccountSubscriptionResponse = $this->ServiceAccount->update_subscription($UpdateAccountSubscriptionRequest );
                $updated = TRUE;
              } catch (SoapFault $fault) {
                throw new Account_Exception("Soap error :".$fault);
                return false;
              }
            }
          }
        }
        */
/*
        if ( $this->account_info['expiration_date'] == '' || !isset( $this->account_info['expiration_date'] ) || $this->account_info['expiration_date'] == NULL ){
          $this->account_info['expiration_date'] = date('Y-m-d');
        }
*/
  
$expiration_date = date( 'Y-m-d' , max( strtotime( date('Y-m-d') ) , strtotime( $this->account_info['expiration_date'] ) ) ) ;

//$subscription->finish_date = date('Y-m-d', strtotime('+'.$SubscriptionPlans[$i_subscription_plan]['RenewalPeriodMonths'].' months', strtotime( $expiration_date ) ) );

        $AccountInfo = array(
          'i_account' => $this->account_info['i_account'],
          'expiration_date' => date('Y-m-d', strtotime('+'.$SubscriptionPlans[$i_subscription_plan]['RenewalPeriodMonths'].' months', strtotime( $expiration_date ) ) ),
        );

        $UpdateAccountRequest = array(
          'account_info' => $AccountInfo,
        );

        try {
          $AddUpdateAccountResponse = $this->ServiceAccount->update_account($UpdateAccountRequest);
          $updated = TRUE;
        } catch (SoapFault $fault) {
          throw new Account_Exception("Soap error :".$fault);
          return false;
        }


        if ( $updated == FALSE ){
          $subscription = array(
            'i_subscription' => $PB_Prepaid_Subscription_Plans[$this->account_info['iso_4217']],
            'finish_date' => date('Y-m-d', strtotime( '+'.$SubscriptionPlans[$i_subscription_plan]['RenewalPeriodMonths'].' months' ) ),
          );
          $AddAccountSubscriptionRequest =  array( 
             'i_account' => $this->account_info['i_account'],
             'subscription_info' => $subscription
          );
          try {
            $AddUpdateAccountSubscriptionResponse = $this->ServiceAccount->add_subscription($AddAccountSubscriptionRequest);
            $updated = TRUE;
          } catch (SoapFault $fault) {
            throw new Account_Exception("Soap error :".$fault);
            return false;
          }
        }
      }
    }

    try {
      $text_value = 'no subscription plan';
      if ( $i_subscription_plan == 1 ){
        $text_value = '1 month';
      } elseif ( $i_subscription_plan > 1 ){
        $text_value = $SubscriptionPlans[$i_subscription_plan]['RenewalPeriodMonths'].' months';
      }
      $CustomFieldsValuesInfo = array(
        'name' => 'Prepaid subscription plan',
        //'db_value' => $i_subscription_plan,
        'text_value' => $text_value
      );
      $custom_fields_values = array();
      array_push($custom_fields_values, $CustomFieldsValuesInfo);
      $UpdateAccountCustomFieldsValuesRequest  = array(
        'i_account' => $this->account_info['i_account'],
        'custom_fields_values' => $custom_fields_values
      );
//        error_log(print_r($UpdateAccountCustomFieldsValuesRequest , TRUE));
      $UpdateAccountCustomFieldsValuesResponse = $this->ServiceAccount->update_custom_fields_values($UpdateAccountCustomFieldsValuesRequest);
      //error_log(print_r($UpdateAccountCustomFieldsValuesResponse , TRUE));
    } catch (SoapFault $fault) {
      throw new Account_Exception("Soap error :".$fault);
      return false;
    }
    $this->load_account_info();
    return true;
  }

  public function set_auto_renewal( $flag ){
    $text_value = 'no';
    
    if ( $flag ) {
      $text_value = 'yes';
    }

    if ( !isset( $this->account_info['CurrentSubscriptionType'] ) || $this->account_info['CurrentSubscriptionType'] == 0 ){
      $this->account_info['CurrentSubscriptionType'] = 1;
      $this->update_subscription_plan( 1, FALSE );
    }

    try {
      $CustomFieldsValuesInfo = array(
        'name' => 'Auto renewal subscription plan',
        //'db_value' => $i_subscription_plan,
        'text_value' => $text_value
      );
      $custom_fields_values = array();
      array_push($custom_fields_values, $CustomFieldsValuesInfo);

      $UpdateAccountCustomFieldsValuesRequest  = array(
        'i_account' => $this->account_info['i_account'],
        'custom_fields_values' => $custom_fields_values
      );
      $UpdateAccountCustomFieldsValuesResponse = $this->ServiceAccount->update_custom_fields_values($UpdateAccountCustomFieldsValuesRequest);
    } catch (SoapFault $fault) {
      throw new Account_Exception("Soap error :".$fault);
      return false;
    }
    return true;
  }

  public function set_prepaid_private_product(){
    include dirname(__FILE__) . '/../etc/' . "SubscriptionPlans.php";

    $i_product = 33;

    if ( isset( $PB_Private_Prepaid_Products[ $this->account_info['iso_4217'] ] ) ){
      $i_product = $PB_Private_Prepaid_Products[ $this->account_info['iso_4217'] ];
    } else {
      error_log("new i_product not found. using default ".$i_product );
    }

    $AccountInfo = array(
      'i_account' => $this->account_info['i_account'],
      'i_product' => $i_product,
    );

    $UpdateAccountRequest = array(
      'account_info' => $AccountInfo,
    );

    try {
      $AddUpdateAccountResponse = $this->ServiceAccount->update_account($UpdateAccountRequest);
    } catch (SoapFault $fault) {
      throw new Account_Exception("Soap error :".$fault);
      return false;
    }
    return true;
  }

  public function remove_prepaid_private_product(){



  }

  private function web_db_connect(){
    $filename = '/home/site_lib/connections/local.mysqli.class.php';
    if(!@include_once( $filename ) ) throw new Account_Exception( "Failed to include ". $filename );
    try {
      $LocalMysql = new LocalMysqli;
      $this->LocalMysqli = $LocalMysql->connection;
      $this->LocalMysqli->set_charset("utf8");
      return $this->LocalMysqli;
    } catch (mysqli_sql_exception $e) {
      throw new Account_Exception("Could not connect to mysql server !".$e);
    }
  }

  private function soap_connect(){

    $filename = "credentials/soap.conf.php";
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );

    $filename = 'classes/PortaBillingSoapClient.php';
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );

    $SOAPCredentials = new SOAPCredentials;
    $SOAP_user = $SOAPCredentials->get_user();
    $SOAP_pass = $SOAPCredentials->get_password();

    if ( isset( $this->SOAP_session_id ) && $this->SOAP_session_id != '' ){
      try {
        $this->ServiceCustomer = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Customer');
        $session_id = $this->ServiceCustomer->_setSessionId( $this->SOAP_session_id );
        $this->ServiceAccount = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Account');
        $this->ServiceAccount->_setSessionId( $this->SOAP_session_id );
        error_log("[Account.php]  USING SOAP SESSION ID : ".$this->SOAP_session_id);
        //print_r($this->ServiceAccount, TRUE);
        return $this->SOAP_session_id;
      } catch (SoapFault $e) {
        throw new Customer_Exception("Could not connect to porta-billing SOAP server !");
      }
    } else {
      try {
        $this->ServiceCustomer = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Customer');
        $session_id = $this->ServiceCustomer->_login($SOAP_user, $SOAP_pass);
        $this->SOAP_session_id = $session_id;
        $this->ServiceAccount = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Account');
        //$session_id2 = $this->ServiceAccount->_login($SOAP_user, $SOAP_pass);
        $this->ServiceAccount->_setSessionId( $this->SOAP_session_id );
        error_log("[Account.php]  NEW SOAP SESSION ID : ".$this->SOAP_session_id);
        return $session_id;
      } catch (SoapFault $e) {
        throw new Customer_Exception("Could not connect to porta-billing SOAP server !");
      }
    }
  }

  private function master_db_connect(){
    $filename = 'connections/master.mysqli.class.php';
    if(!@include_once( $filename ) ) throw new Account_Exception( "Failed to include ". $filename );
    try {
      $MasterMysqli = new MasterMysqli;
      $this->MasterMysqli = $MasterMysqli->connection;
      return $this->MasterMysqli;
    } catch (mysqli_sql_exception $e) {
      throw new Account_Exception("Could not connect to mysql server !".$e);
    }
  }

  private function stmt_bind_assoc (&$stmt, &$out) {
    global $mysqli;
    $data = $stmt->result_metadata();
    $fields = array();
    $out = array();
    $fields[0] = $stmt;
    $count = 1;
    while($field = $data->fetch_field()) {
      $fields[$count] = &$out[$field->name];
      $count++;
    }    
    call_user_func_array('mysqli_stmt_bind_result', $fields);
  }

}

class Account_Exception extends Exception{
  public function __construct($message = null, $code = 0, Exception $previous = null) {
    try {
        mail('nicolas.bondier@switzernet.com.test-google-a.com',
           'Customer management error',
           $message . "\n\n" . "Message sent from web server :" . __FILE__);
        echo "Erreur :".$message;
    } catch(Exception $e) { 
      echo $e."\n";
    }
  }
}

?>