<?php

/**
* 
*/
class Customer
{
  public $customer_info;
  public $update_flag;
  public $porta_billing_customer = FALSE;
  public $web_subscription = FALSE;

  private $LocalMysqli;
  private $MasterMysqli;
  private $ServiceCustomer;
  private $ServiceAccount;
  private $SOAP_session_id = '';

  function __construct() {
    $this->web_db_connect();
    $this->master_db_connect();
    $this->soap_connect();
  }

  function __destruct(){
    $this->LocalMysqli->close();
    $this->MasterMysqli->close();
  }

  /*
  function __sleep(){
    $this->LocalMysqli->close();
    $this->MasterMysqli->close();
  }
  */
  
  function __wakeup(){
    $this->soap_connect();
    $this->web_db_connect();
    $this->master_db_connect();
  }

  public function load_customer_info( $check_update = FALSE ){
    $old_customer_info = $this->customer_info;

    if ( $this->porta_billing_customer === FALSE && $this->web_subscription === TRUE  ){
      $sql = "SELECT active_in_porta_billing, pb_i_customer FROM Web_Subscriptions WHERE i_web_subscription = ?";
      $stmt = $this->LocalMysqli->prepare($sql);
      $state = $stmt->bind_param( "i", $this->customer_info['i_web_subscription'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      $stmt->fetch();
      $stmt->close();
      if ( $res['active_in_porta_billing'] == 1 ){
        $sql = "SELECT IF(COUNT(*) > 0, 'true', 'false') as found FROM Customers WHERE i_customer = ?";
        $stmt = $this->MasterMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $res['i_customer'] );
        $res2=array();
        $this->stmt_bind_assoc($stmt, $res2);
        $stmt->fetch();
        $stmt->close();
        if ( $res2['found'] == 'true' ){
          $this->porta_billing_customer = TRUE;
          $this->load_customer_info();
        } else {
          $sql = "UPDATE Web_Subscriptions SET active_in_porta_billing = 0, pb_i_customer = NULL WHERE i_web_subscription = ?";
          $stmt = $this->LocalMysqli->prepare($sql);
          $state = $stmt->bind_param( "ii", $amount, $this->customer_info['i_web_subscription'] );
          $stmt->execute();
          $stmt->close();
        }
      }
    }

    if ( $this->porta_billing_customer ){
      $sql = "SELECT c.*, a.id, a.i_account FROM Customers c INNER JOIN Accounts a ON a.i_customer=c.i_customer WHERE c.i_customer = ? AND a.bill_status = 'O'";
      $stmt = $this->MasterMysqli->prepare($sql);
      $state = $stmt->bind_param( "i", $this->customer_info['i_customer'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      $stmt->fetch();
      $stmt->close();
      if ( $res['i_customer'] > 0 ){
        foreach ($res as $key => $value) {
          $this->customer_info[$key] = $value;
        }
      } else {
        return FALSE;
      }

      $this->customer_info['Active']     = TRUE;
      $this->customer_info['Email']      = $this->customer_info['email'];
      $this->customer_info['Firstname']  = $this->customer_info['firstname'];
      $this->customer_info['Lastname']   = $this->customer_info['lastname'];
      $this->customer_info['Address'] = '';
      foreach (array( 'baddr1', 'baddr2', 'baddr3', 'baddr4', 'baddr5' ) as $value) {
        $this->customer_info['Address'] .= $this->customer_info[$value];
      }
      $this->customer_info['NPA']        = $this->customer_info['zip'];
      $this->customer_info['City']       = $this->customer_info['city'];
      $this->customer_info['Country']    = $this->customer_info['country'];
      $this->customer_info['Balance']    = number_format($this->customer_info['balance'],2);
      $this->customer_info['Currency']   = $this->customer_info['iso_4217'];
      $this->customer_info['WebLogin']   = $this->customer_info['login'];
      
      $this->customer_info['Company']    = $this->customer_info['companyname'];
      $this->customer_info['WebPassword']   = $this->customer_info['password'];
      $this->customer_info['CreditLimit'] = $this->customer_info['credit_limit'];

      $this->get_payment_method();
/*
      if ( $this->customer_info['i_credit_card'] != NULL && $this->customer_info['i_credit_card'] > 0 ){
        $sql = "SELECT * FROM Credit_Cards cc INNER JOIN Payment_Methods pm ON cc.i_payment_method = pm.i_payment_method WHERE i_credit_card = ?";
        $stmt = $this->MasterMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $this->customer_info['i_credit_card'] );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        $stmt->close();
        if ( $res['i_credit_card'] > 0 ){
          if ( $res['payment_method'] == 'PayPal' ){
            $this->customer_info['AutomaticPaymentMethod'] = 'PayPal';
            
          } elseif ( $res['payment_method'] == 'VISA' ) {
            $this->customer_info['AutomaticPaymentMethod'] = 'VISA';

          } elseif ( $res['payment_method'] == 'MasterCard' ) {
            $this->customer_info['AutomaticPaymentMethod'] = 'MasterCard';

          }
        }
      }
      */
    } elseif ( $this->web_subscription === TRUE ) {

      $sql = "SELECT * FROM Web_Subscriptions WHERE i_web_subscription = ?";
      $stmt = $this->LocalMysqli->prepare($sql);
      $state = $stmt->bind_param( "i", $this->customer_info['i_web_subscription'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      $stmt->fetch();
      $stmt->close();
      if ( $res['i_web_subscription'] > 0 ){
        //print_r($res);
        $this->customer_info = $res;
      } else {
        return FALSE;
      }
      $this->customer_info['Active']     = FALSE;

      // Map the subscription with the class variables

      $this->customer_info['AutomaticPaymentMethod']   = '';
      $this->customer_info['AutomaticPaymentStatus']   = '';
      $this->customer_info['WebLogin']   = $this->customer_info['web_login'];
      $this->customer_info['Balance']    = $this->customer_info['Total_order'];
      $this->customer_info['Company']    = $this->customer_info['Company_Name'];
      $this->customer_info['WebPassword']   = $this->customer_info['web_password'];
      $this->customer_info['CreditLimit'] = 0;
    }

    $this->customer_info['AvailableFunds'] = max( ( $this->customer_info['CreditLimit'] - $this->customer_info['Balance'] ), 0 );
    $this->customer_info['AvailableFunds'] = ( $this->customer_info['CreditLimit'] - $this->customer_info['Balance'] );

    $this->get_customer_prepaid_accounts();

    $new_customer_info = $this->customer_info;

    if ( $check_update == TRUE && $new_customer_info != $old_customer_info ){
      $this->update_flag = TRUE;
    } else {
      $this->update_flag = FALSE;
    }
    $sql = "SELECT NOW() as CurrentTime";
    $stmt = $this->MasterMysqli->prepare($sql);
    $stmt->execute();
    $this->stmt_bind_assoc($stmt, $res);
    $stmt->fetch();
    $stmt->close();
    $Customer->customer_info['CurrentTime'] = $res['CurrentTime'];
    //print_r($this);
    return TRUE;
  }

  public function authenticate( $user, $password ){
    //print_r($this);
    $sql = "SELECT i_customer FROM Customers WHERE login = ? AND password = ?";
    //echo $sql;
    $stmt = $this->MasterMysqli->prepare($sql);
    /* Prepared statement, stage 1: prepare */
    $state = $stmt->bind_param( "ss", $user, $password );
    $stmt->execute();
    $res=array();
    $this->stmt_bind_assoc($stmt, $res);
    $stmt->fetch();
    $stmt->close();

    //print_r($res);

    if ( $res['i_customer'] > 0 ){
      $this->customer_info['i_customer'] = $res['i_customer'];
      $this->porta_billing_customer = TRUE;
      return TRUE;
    } else {
      $sql = "SELECT i_web_subscription FROM Web_Subscriptions WHERE web_login = ? AND web_password = ?";
      $stmt = $this->LocalMysqli->prepare($sql);
      $state = $stmt->bind_param( "ss", $user, $password );
      $stmt->execute();
      $res2=array();
      $this->stmt_bind_assoc($stmt, $res2);
      $stmt->fetch();
      $stmt->close();
      if ( $res2['i_web_subscription'] > 0 ){
        $this->customer_info['i_web_subscription'] = $res2['i_web_subscription'];
        $this->web_subscription = TRUE;
        return TRUE;
      }
    }
    return FALSE;
  }

  public function set_customer ($i_customer){
    //print_r($this);
    $sql = "SELECT i_customer FROM Customers WHERE i_customer = ?";
    //echo $sql;
    $stmt = $this->MasterMysqli->prepare($sql);
    /* Prepared statement, stage 1: prepare */
    $state = $stmt->bind_param( "i", $i_customer );
    $stmt->execute();
    $res=array();
    $this->stmt_bind_assoc($stmt, $res);
    $stmt->fetch();
    $stmt->close();

    //print_r($res);

    if ( $res['i_customer'] > 0 ){
      $this->customer_info['i_customer'] = $res['i_customer'];
      $this->porta_billing_customer = TRUE;
      return TRUE;
    }
    return FALSE;
  }

  public function charge( $amount, $visible_comment = 'order', $internal_comment = 'prepaid interface order' ){

    $MakeCustomerTransactionRequest = array(
      'i_customer'            => $this->customer_info['i_customer'],
      'visible_comment'       => $visible_comment,
      'internal_comment'      => $internal_comment,
      'action'                => 'Manual charge',
      'amount'                => $amount,
      'suppress_notification' => 0,
    );
    try {
      $MakeCustomerTransactionResponse = $this->ServiceCustomer->make_transaction($MakeCustomerTransactionRequest);
      $this->load_customer_info();
      return true;
    } catch (SoapFault $fault) {
      throw new Customer_Exception("Soap error :".$fault);
      return false;
    }
  }

  public function update_payment_method( $payment_method_data ){

    $pm = $payment_method_data['AutomaticPaymentMethod'];

    //error_log(print_r($payment_method_data,true));
    //return $payment_method_data;


    $return = array(
      'status' => NULL,
      'message' => NULL
    );

    if ( $pm != 'VISA' && $pm != 'MasterCard' && $pm != 'PayPal' && $pm != '' ){
      $return = array(
        'status' => 'error',
        'message' => l('Wrong payment method'),

      );
      return $return;
    }

    if (  $pm == 'VISA' || $pm == 'MasterCard' ){

      if ( ! isset( $payment_method_data['card_owner'] ) || $payment_method_data['card_owner'] == '' ){
        $return = array(
          'status' => 'error',
          'message' => l('Card owner is missing'),
        );
        return $return;
      }

      if ( ! isset( $payment_method_data['card_number'] ) || $payment_method_data['card_number'] == '' ){
        $return = array(
          'status' => 'error',
          'message' => ('Card number is missing'),
        );
        return $return;
      }

      if ( ! isset( $payment_method_data['cvv'] ) || $payment_method_data['cvv'] == '' ){
        $return = array(
          'status' => 'error',
          'message' => l('Card cvv is missing'),
        );
        return $return;
      }

      if ( ! isset( $payment_method_data['card_month'] ) || $payment_method_data['card_month'] == '' ){
        $return = array(
          'status' => 'error',
          'message' => l('Card month is missing'),
        );
        return $return;
      }

      if ( ! isset( $payment_method_data['card_year'] ) || $payment_method_data['card_year'] == '' ){
        $return = array(
          'status' => 'error',
          'message' => l('Card year is missing'),
        );
        return $return;
      }


      if ( preg_match( '/[0-9]{2}/', $payment_method_data['card_month'] ) && ( $payment_method_data['card_month'] > 12 || $payment_method_data['card_month'] < 1) ){
        $return = array(
          'status' => 'error',
          'message' => l('Wrong card expiration date'),
        );
        return $return;
      }

      if ( preg_match( '/[0-9]{4}/', $payment_method_data['card_year'] ) && ( $payment_method_data['card_year'] < date('Y') ) ){
        $return = array(
          'status' => 'error',
          'message' => l('Card expiration date is in the past'),
        );
        return $return;
      }

      $expiration_date = '0000-00-00';
      $expiration_date = $payment_method_data['card_year'] . '-' . $payment_method_data['card_month'] . '-' . '01';


      if ( isset($this->customer_info['zip']) && $this->customer_info['zip'] != '' ){
        $payment_method_data['zip'] = $this->customer_info['zip'];
      } else {
        $payment_method_data['city'] = 'none';
      }

      if ( isset($this->customer_info['city']) && $this->customer_info['city'] != '' ){
        $payment_method_data['city'] = $this->customer_info['city'];
      } else {
        $payment_method_data['city'] = 'none';
      }

      if ( isset($this->customer_info['address']) && $this->customer_info['address'] != '' ){
        $payment_method_data['address'] = $this->customer_info['address'];
      } else {
        $payment_method_data['address'] = 'none';
      }

      $PaymentMethodInfo = array(
        'payment_method' => $pm,
        'name'           => $payment_method_data['card_owner'],
        'address'        => '',
        'zip'            => $payment_method_data['zip'],
        'city'           => $payment_method_data['city'],
        'number'         => $payment_method_data['card_number'],
        'cvv'            => $payment_method_data['cvv'],
        'exp_date'       => $expiration_date,
        'address'        => $payment_method_data['cvv']
      );

      try {
        $UpdateCustomerPaymentMethodRequest  = $this->ServiceCustomer->update_payment_method(
          array(
            'i_customer' => $this->customer_info['i_customer'],
            'payment_method_info' => $PaymentMethodInfo,
          )
        );
      $this->load_customer_info();
        return true;
      } catch (SoapFault $fault) {
        
        throw new Customer_Exception("Soap error :".$fault);
        return false;
      }
    } elseif ( $pm == 'PayPal' ) {
      $PaymentMethodInfo = array(
        'payment_method' => 'PayPal'
      );

      try {
        $UpdateCustomerPaymentMethodRequest = $this->ServiceCustomer->update_payment_method(
          array(
            'i_customer' => $this->customer_info['i_customer'],
            'payment_method_info' => $PaymentMethodInfo,
          )
        );
        $this->load_customer_info();
        return true;
      } catch (SoapFault $fault) {
        throw new Customer_Exception("Soap error :".$fault);
        return false;
      }
    } else {
      $PaymentMethodInfo = array(
        'payment_method' => NULL
      );
      try {
        $UpdateCustomerPaymentMethodRequest = $this->ServiceCustomer->update_payment_method(
          array(
            'i_customer' => $this->customer_info['i_customer'],
            'payment_method_info' => $PaymentMethodInfo,
          )
        );
        $this->load_customer_info();
        $this->remove_all_accounts_renewal_options();
        return true;
      } catch (SoapFault $fault) {
        throw new Customer_Exception("Soap error :".$fault);
        return false;
      }
    }

/*
    try {    
      $sql = "UPDATE customer_data SET AutomaticPaymentMethod = ?, AutomaticPaymentStatus = ? WHERE i_customer = ?";
      $stmt = $this->LocalMysqli->prepare($sql);
      $state = $stmt->bind_param( "ssi", $payment_method_data['AutomaticPaymentMethod'], $payment_method_data['AutomaticPaymentStatus'], $this->customer_info['i_customer'] );
      $stmt->execute();
      $stmt->close();

      if ( $payment_method_data['AutomaticPaymentMethod'] == '' || $payment_method_data['AutomaticPaymentMethod'] == NULL){
        $sql = "UPDATE account_data SET SubscriptionAutoRenewal = 0 WHERE i_customer = ?";
        $stmt = $this->LocalMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $this->customer_info['i_customer'] );
        $stmt->execute();
        $stmt->close();
      }
      $this->load_customer_info();
      return true;
    } catch (mysqli_sql_exception $e) {
      throw new Customer_Exception("MySQL error ".$this->LocalMysqli->error." <br> Query:<br> $sql", $this->LocalMysqli->errno);
      return false;
    }
*/
  }

  private function remove_all_accounts_renewal_options(){
    file_put_contents('/tmp/AccountsList.txt', print_r( $this->customer_info['AccountsList'] , true ) );
    foreach ( $this->customer_info['AccountsList'] as $i_account => $number) {
      try {
        $CustomFieldsValuesInfo = array(
          'name' => 'Auto renewal subscription plan',
          //'db_value' => $i_subscription_plan,
          'text_value' => 'no'
        );
        $custom_fields_values = array();
        array_push($custom_fields_values, $CustomFieldsValuesInfo);

        $UpdateAccountCustomFieldsValuesRequest  = array(
          'i_account' => $i_account,
          'custom_fields_values' => $custom_fields_values
        );
        $UpdateAccountCustomFieldsValuesResponse = $this->ServiceAccount->update_custom_fields_values($UpdateAccountCustomFieldsValuesRequest);
      } catch (SoapFault $fault) {
        throw new Account_Exception("Soap error :".$fault);
        return false;
      }
    }
    return true;
  }

  private function get_payment_method(){
    if ( $this->customer_info['i_credit_card'] != NULL && $this->customer_info['i_credit_card'] > 0 ){
      $cols = array();
      $cols_array = array();

      $sql = "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = 'Credit_Cards'";
      if (!($stmt = $this->MasterMysqli->prepare($sql))) {
        echo "Echec de la préparation : (" . $MasterMysqli->errno . ") " . $MasterMysqli->error;
      }
      $stmt->execute();
      $this->stmt_bind_assoc($stmt, $res);
      while ( $stmt->fetch() ) {
        array_push($cols_array, $res['COLUMN_NAME']);
      }
      $stmt->close();

      $cols_string = implode($cols_array,"`,`");

      $sql = "SELECT SHA1(CONCAT_WS(`".$cols_string."`)) as credit_card_hash FROM Credit_Cards WHERE i_credit_card = ?";
      //echo $sql;
      if (!($stmt = $this->MasterMysqli->prepare($sql))) {
        echo "Echec de la préparation : (" . $MasterMysqli->errno . ") " . $MasterMysqli->error;
      }
      $stmt->bind_param( "i", $this->customer_info['i_credit_card'] );
      $stmt->execute();
     
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      $stmt->fetch();

      //echo $this->customer_info['credit_card_hash'];

      if ( !isset( $this->customer_info['AutomaticPaymentMethod'] ) ) $this->customer_info['AutomaticPaymentMethod'] = '';
      if ( !isset( $this->customer_info['AutomaticPaymentCustomNumber'] ) ) $this->customer_info['AutomaticPaymentCustomNumber'] = '';
      if ( !isset( $this->customer_info['AutomaticPaymentStatus'] ) ) $this->customer_info['AutomaticPaymentStatus'] = '';

      if ( !isset( $this->customer_info['credit_card_hash'] ) || $this->customer_info['credit_card_hash'] != $res['credit_card_hash'] ){
        $this->customer_info['credit_card_hash'] = $res['credit_card_hash'];
        $GetCustomerPaymentMethodInfoRequest = array( 'i_customer' => $this->customer_info['i_customer'] );
        $GetCustomerPaymentMethodInfoResponse = $this->ServiceCustomer->get_payment_method_info($GetCustomerPaymentMethodInfoRequest);
        error_log(print_r($GetCustomerPaymentMethodInfoResponse->payment_method_info, true));

        if ( isset( $this->customer_info['AutomaticPaymentCustomNumber'] ) ){
          $this->customer_info['AutomaticPaymentCustomNumber']   = $GetCustomerPaymentMethodInfoResponse->payment_method_info->number;
        } else {
          $this->customer_info['AutomaticPaymentCustomNumber'] = '';
        }

        if ( isset( $this->customer_info['AutomaticPaymentMethod'] ) ){
          $this->customer_info['AutomaticPaymentMethod'] = $GetCustomerPaymentMethodInfoResponse->payment_method_info->payment_method;
        } else {
          $this->customer_info['AutomaticPaymentMethod'] = '';
        }
        $this->customer_info['AutomaticPaymentStatus'] = '';
      }
      if ( $this->customer_info['AutomaticPaymentMethod'] == 'PayPal' ){
        $sql = "SELECT * FROM CustomerPayPalPreapprovedPayments WHERE i_customer = ?";
        $stmt = $this->LocalMysqli->prepare($sql);
        $state = $stmt->bind_param( "i", $this->customer_info['i_customer'] );
        $stmt->execute();
        $res=array();
        $this->stmt_bind_assoc($stmt, $res);
        $stmt->fetch();
        $stmt->close();
        if ( $res['i_customer'] > 0 ){
          $this->customer_info['AutomaticPaymentCustomNumber'] = $res['senderEmail'];
          if ( $res['approved'] == 1 ){
            $this->customer_info['AutomaticPaymentStatus'] = 'approved';
          } else {
            $this->customer_info['AutomaticPaymentStatus'] = 'pending';
          }
        } else {
          $this->customer_info['AutomaticPaymentStatus'] = 'unknown';
        }
      }
      // print_r($this->customer_info);
    }
  }


  public function get_customer_prepaid_accounts(){
    $accounts = array();
    if ( $this->porta_billing_customer ){
      $sql = 'SELECT a.i_account, a.id as ID FROM Accounts a INNER JOIN Products p ON a.i_product = p.i_product WHERE a.i_customer = ? AND a.bill_status = "O" and p.name like "%prepaid%" ';
      if (!($stmt = $this->MasterMysqli->prepare($sql))) {
          echo "Echec de la préparation : (" . $MasterMysqli->errno . ") " . $LocalMysqli->error;
      }
      $state = $stmt->bind_param( "i", $this->customer_info['i_customer'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      while ( $stmt->fetch() ) {
        $accounts[$res['i_account']] = $res['ID'];
      }
      $this->customer_info['AccountsList'] = $accounts;
      return $accounts;
    } else {
      $sql = "SELECT i_web_subscription_reserved_number, h323_id as ID FROM Web_Subscription_Selected_Numbers wssn INNER JOIN Web_Subscriptions ws ON wssn.i_web_subscription = ws.i_web_subscription WHERE wssn.i_web_subscription = ? AND Account_Type = 'pre'";
      if (!($stmt = $this->LocalMysqli->prepare($sql))) {
          echo "Echec de la préparation : (" . $this->LocalMysqli->errno . ") " . $this->LocalMysqli->error;
      }
      $state = $stmt->bind_param( "i", $this->customer_info['i_web_subscription'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      while ( $stmt->fetch() ) {
        $accounts[$res['i_web_subscription_reserved_number']] = $res['ID'];
      }
      $this->customer_info['AccountsList'] = $accounts;
      return $accounts;
    }
  }


  public function get_customer_accounts(){
    $accounts = array();
    if ( $this->porta_billing_customer ){
      $sql = 'SELECT a.i_account, a.id as ID FROM Accounts a  WHERE a.i_customer = ? AND a.bill_status = "O"';
      if (!($stmt = $this->MasterMysqli->prepare($sql))) {
          echo "Echec de la préparation : (" . $MasterMysqli->errno . ") " . $LocalMysqli->error;
      }
      $state = $stmt->bind_param( "i", $this->customer_info['i_customer'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      while ( $stmt->fetch() ) {
        $accounts[$res['i_account']] = $res['ID'];
      }
      //$this->customer_info['AccountsList'] = $accounts;
      return $accounts;
    } else {
      $sql = "SELECT i_web_subscription_reserved_number, h323_id as ID FROM Web_Subscription_Selected_Numbers wssn INNER JOIN Web_Subscriptions ws ON wssn.i_web_subscription = ws.i_web_subscription WHERE wssn.i_web_subscription = ? AND Account_Type = 'pre'";
      if (!($stmt = $this->LocalMysqli->prepare($sql))) {
          echo "Echec de la préparation : (" . $this->LocalMysqli->errno . ") " . $this->LocalMysqli->error;
      }
      $state = $stmt->bind_param( "i", $this->customer_info['i_web_subscription'] );
      $stmt->execute();
      $res=array();
      $this->stmt_bind_assoc($stmt, $res);
      while ( $stmt->fetch() ) {
        $accounts[$res['i_web_subscription_reserved_number']] = $res['ID'];
      }
      //$this->customer_info['AccountsList'] = $accounts;
      return $accounts;
    }
  }

  private function web_db_connect(){
    $filename = '/home/site_lib/connections/local.mysqli.class.php';
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );
    try {
      $LocalMysql = new LocalMysqli;
      $this->LocalMysqli = $LocalMysql->connection;
      $this->LocalMysqli->set_charset("utf8");
      return $this->LocalMysqli;
    } catch (mysqli_sql_exception $e) {
      throw new Customer_Exception("Could not connect to mysql server !".$e);
    }
  }

  private function master_db_connect(){
    $filename = 'connections/master.mysqli.class.php';
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );
    try {
      $MasterMysqli = new MasterMysqli;
      $this->MasterMysqli = $MasterMysqli->connection;
      return $this->MasterMysqli;
    } catch (mysqli_sql_exception $e) {
      throw new Customer_Exception("Could not connect to mysql server !".$e);
    }
  }

  private function soap_connect(){

    $filename = "credentials/soap.conf.php";
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );

    $filename = 'classes/PortaBillingSoapClient.php';
    if(!@include_once( $filename ) ) throw new Customer_Exception( "Failed to include ". $filename );

    $SOAPCredentials = new SOAPCredentials;
    $SOAP_user = $SOAPCredentials->get_user();
    $SOAP_pass = $SOAPCredentials->get_password();

    if ( isset( $this->SOAP_session_id ) && $this->SOAP_session_id != '' ){
      try {
        $this->ServiceCustomer = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Customer');
        $session_id = $this->ServiceCustomer->_setSessionId( $this->SOAP_session_id );
        $this->ServiceAccount = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Account');
        $this->ServiceAccount->_setSessionId( $this->SOAP_session_id );
        error_log("[Customer.php] USING SOAP SESSION ID : ".$this->SOAP_session_id);
        //print_r($this->ServiceAccount, TRUE);
        return $this->SOAP_session_id;
      } catch (SoapFault $e) {
        throw new Customer_Exception("Could not connect to porta-billing SOAP server !");
      }

    } else {
      try {
        $this->ServiceCustomer = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Customer');
        $session_id = $this->ServiceCustomer->_login($SOAP_user, $SOAP_pass);
        $this->SOAP_session_id = $session_id;
        $this->ServiceAccount = new PortaBillingSoapClient('https://slave.switzernet.com:8444', 'Admin', 'Account');
        //$session_id2 = $this->ServiceAccount->_login($SOAP_user, $SOAP_pass);
        $this->ServiceAccount->_setSessionId( $this->SOAP_session_id );
        error_log("[Customer.php] NEW SOAP SESSION ID : ".$this->SOAP_session_id);
        return $session_id;
      } catch (SoapFault $e) {
        throw new Customer_Exception("Could not connect to porta-billing SOAP server !");
      }
    }
  }

  private function stmt_bind_assoc (&$stmt, &$out) {
    global $mysqli;
    $data = $stmt->result_metadata();
    $fields = array();
    $out = array();
    $fields[0] = $stmt;
    $count = 1;
    while($field = $data->fetch_field()) {
      $fields[$count] = &$out[$field->name];
      $count++;
    }    
    call_user_func_array('mysqli_stmt_bind_result', $fields);
  }

  private function microtime_float()
  {
      list($usec, $sec) = explode(" ", microtime());
      return ((float)$usec + (float)$sec);
  }

  public function _close(){
    $this->LocalMysqli->close();
    $this->MasterMysqli->close();
  }
}

class Customer_Exception extends Exception{
  public function __construct($message = null, $code = 0, Exception $previous = null) {
    try {
        mail('nicolas.bondier@switzernet.com.test-google-a.com',
           'Customer management error',
           $message . "\n\n" . "Message sent from web server :" . __FILE__);
        echo "Erreur :".$message;
    } catch(Exception $e) { 
      echo $e."\n";
    }
  }
}

?>