<!DOCTYPE html>
<html lang="en" class="ng-scope">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <title class="ng-binding">Language management</title>
    <link rel="stylesheet" media="screen,projection" href="../css/pure-min.css">
    <!-- <link rel="stylesheet" media="screen,projection" href="../css/common2.css"> -->
    <script src="../js/jquery-1.11.1.min.js"></script>
    <script src="../js/jquery.color-2.1.2.min.js"></script>
    <link rel="shortcut icon" href="../images/favicon.ico">
  </head>
<body>

<?php

?>

    <div id="body-container">
    <div id="page-container" style="margin:20px;">
<h1>Language management</h1>

<?php

$NEW_TRANSLATION_TO_SEND = array();

// SELECT ALL FROM FILES

$path_to_check = $_SERVER['DOCUMENT_ROOT'].'/3/company/141029-prepaid-subscription-web-interface/';

$expressions = array();

foreach (new RecursiveIteratorIterator(new RecursiveDirectoryIterator( $path_to_check )) as $filename) {
  if ( ! preg_match('/^.*\.php$/', $filename) ) continue;
  $file = file_get_contents($filename);

/* // Testing
  if ( preg_match_all('/[^a-zA-Z0-9_\x7f-\xff]l\(["\']{1}(.*?)["\']{1}\)/s', $file, $matches) ){
    foreach ( $matches[1] as $found ) {
      echo "FOUND :".$matches[1]."\n";
    }
  }
  */

  if ( preg_match_all('/[^a-zA-Z0-9_\x7f-\xff]l\(["\']{1}(.*?)["\']{1}\)/s', $file, $matches) ){
    foreach ( $matches[1] as $found ) {
      //$constant = str_replace('\'', '\\\'', $found);
      $constant = $found;
      array_push( $expressions , $constant );
    }
  }
}


$uniq_expressions = array_flip( $expressions );
$expressions = array();

foreach ($uniq_expressions as $key => $value) {
  $expressions[$value] = $key;
}

// SELECT ALL FROM DB

$UPDATE_LANGUAGES = FALSE;
if ( isset( $_POST ) && isset( $_POST['action'] ) && isset( $_POST['i_constant'] ) && isset( $_POST['translation'] ) && $_POST['action'] == 'save_translation' ){
  $UPDATE_LANGUAGES = TRUE;
}

if ( $UPDATE_LANGUAGES ){
  if ( file_exists(dirname(__FILE__).'/db/current.sqlite3') ){
    copy( dirname(__FILE__).'/db/current.sqlite3', dirname(__FILE__).'/db/'.date('Y-m-d_H').'0000.sqlite3.save' );
  }
}

try {
    $pdo = new PDO('sqlite:'.dirname(__FILE__).'/db/current.sqlite3');
    $pdo->setAttribute(PDO::ATTR_DEFAULT_FETCH_MODE, PDO::FETCH_ASSOC);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); // ERRMODE_WARNING | ERRMODE_EXCEPTION | ERRMODE_SILENT
} catch(Exception $e) {
    echo "Impossible d'accéder à la base de données SQLite : ".$e->getMessage();
    die();
}

$columns = array();
$stmt = $pdo->prepare("SELECT name FROM sqlite_master WHERE type='table' AND name like 'lang_%';");
$stmt->execute();
$columns = $stmt->fetchAll();

if ( $UPDATE_LANGUAGES ){
  foreach ($columns as $column) {
    if ( preg_match('/^lang_(.+)$/', $column['name'], $matches) ){
      if ( isset( $_POST['translation'][$column['name']] ) && $_POST['translation'][$column['name']] != '' ){
        $stmt = $pdo->prepare("INSERT OR IGNORE INTO ".$column['name']." (i_constant, translation) VALUES ( :i_constant , :translation ) ");
        $stmt->execute(array('translation' => stripcslashes($_POST['translation'][$column['name']]), 'i_constant' => $_POST['i_constant'] ));
        $stmt = $pdo->prepare("UPDATE ".$column['name']." SET translation = :translation WHERE i_constant = :i_constant ");
        $stmt->execute(array('translation' => stripcslashes($_POST['translation'][$column['name']]), 'i_constant' => $_POST['i_constant'] ));
      }
    }
  }
}

$sql = "SELECT * FROM constants";
$stmt = $pdo->prepare($sql);
$stmt->execute();
$results = $stmt->fetchAll();

// IF IS IN DB BUT NOT IN FILES, THEN WE MUST REMOVE FROM DATABASE
$db_constants = array();
foreach ($results as $result) {
  $db_constants[$result['constant']] = TRUE;
  if ( ! isset( $uniq_expressions[$result['constant']] ) ){
    $stmt = $pdo->prepare("DELETE FROM constants WHERE i_constant = :i_constant");
    $stmt->execute(array('i_constant' => $result['i_constant'] ));
    //echo "deleting : ".$result['constant']."\n";
    foreach ($columns as $column) {
      if ( preg_match('/^lang_(.+)$/', $column['name'], $matches) ){
        $stmt = $pdo->prepare("DELETE FROM ".$column['name']." WHERE i_constant = :i_constant");
        $stmt->execute(array('i_constant' => $result['i_constant'] ));
      }
    }
  }
}

// IF IS NOT IN DB, WE MUST INSERT.

foreach ($uniq_expressions as $key => $value) {
  if ( !isset( $db_constants[$key] ) ){
    $stmt = $pdo->prepare("REPLACE INTO constants ( constant ) VALUES (:constant)");
    $stmt->execute(array('constant' => $key ));
    array_push($NEW_TRANSLATION_TO_SEND, $key);
  }
}

$columns = array();
$stmt = $pdo->prepare("SELECT name FROM sqlite_master WHERE type='table' AND name like 'lang_%';");
$stmt->execute();
$columns = $stmt->fetchAll();

?>

<table class="pure-table">
  <thead>
<tr>
  <th>constant (default value)</th>
<?php

//echo l("this is a test");

$translations = array();
$lang_order = array();

foreach ($columns as $column) {
  if ( preg_match('/^lang_(.+)$/', $column['name'], $matches) ){
    array_push($lang_order, $column['name']);
    echo "<th>".strtolower($matches[1])."</th>\n";
    $stmt = $pdo->prepare("SELECT * FROM ".$column['name']."");
    $stmt->execute();
    $tmp = $stmt->fetchAll(PDO::FETCH_KEY_PAIR);
    //print_r($tmp);
    foreach ($tmp as $key => $value) {
      $translations[ $column['name'] ][$key] = $value;
    }
  }
}
echo "  <th>act.</th>";
echo "</thead>";
echo "<tbody>";

$sql = "SELECT * FROM constants";
$stmt = $pdo->prepare($sql);
$stmt->execute();
$results = $stmt->fetchAll();
foreach ($results as $value) {
  $blink_class = "";
  if ( $value['i_constant'] == $_POST['i_constant'] ){
    $blink_class = "blink-saved-row";
  } 
  echo "<tr class='".$blink_class."'>";
  echo "<td>".$value['constant']."</td>\n";
  foreach ($lang_order as $lang) {
    echo "  <td>";
    if ( isset( $translations[$lang][$value['i_constant']] ) ){
      echo "<textarea data-i-constant=\"".$lang."\" >".$translations[$lang][$value['i_constant']]."</textarea>\n";
    } else {
      echo "<textarea data-i-constant=\"".$lang."\" ></textarea>\n";
    }
    echo "  </td>\n";
  }
  echo "  <td><button onclick=\"saveRow(".$value['i_constant'].",this)\">save</button></td>";
  echo "</tr>\n";
}
echo "</tbody>";

?>
</table>

<script type="text/javascript">

function saveRow( i_constant, element ){
  var form = document.createElement("form");
  form.setAttribute("method", "post");
  form.setAttribute("action", "");
  form.setAttribute("id", "saveRow");
  $(form).hide();

  var hiddenField = document.createElement("input");
  hiddenField.setAttribute("type", "hidden");
  hiddenField.setAttribute("name", 'i_constant' );
  hiddenField.setAttribute("value", i_constant );
  form.appendChild(hiddenField);

  var hiddenField = document.createElement("input");
  hiddenField.setAttribute("type", "hidden");
  hiddenField.setAttribute("name", 'action' );
  hiddenField.setAttribute("value", 'save_translation' );
  form.appendChild(hiddenField);


  var row = getParentElementByTagName(element,'tr');

  for (var j = 0, col; col = row.cells[j]; j++) {
    if ( row.cells[j].childNodes[0] && row.cells[j].childNodes[0].type == 'textarea' ){
      var attr = $(row.cells[j].childNodes[0]).attr('data-i-constant');
      if (typeof attr !== typeof undefined && attr !== false) {
        console.log(row.cells[j].childNodes[0]);
        var hiddenField = document.createElement("input");
        hiddenField.setAttribute("type", "hidden");
        hiddenField.setAttribute("name", 'translation['+ $( row.cells[j].childNodes[0] ).attr('data-i-constant') + ']' );
        hiddenField.setAttribute("value", $(row.cells[j].childNodes[0]).val() );
        form.appendChild(hiddenField);
      }
    }
  }
  document.body.appendChild(form);
  $( form ).submit();
}

function getParentElementByTagName( element , tag ){
  while( element.tagName.toLowerCase() != tag.toLowerCase() ){
    element = element.parentNode;
    if (!element.tagName) {
      return;
    }
  }
  return element;
}

$( document ).ready(function() {
  $(".blink-saved-row").animate({
    backgroundColor: "#66FF66"
  }, 500 );
  $(".blink-saved-row").animate({
    backgroundColor: "transparent"
  }, 1500 );
});

</script>

<div style="hidden">

</div>
<?php

if ( sizeof($NEW_TRANSLATION_TO_SEND) > 0 ){
  require_once 'classes/PHPMailer/class.phpmailer.php';
  $mail = new PHPMailer;
  $mail->CharSet = 'UTF-8';
  $mail->From = 'contracts@switzernet.com';
  $mail->FromName = 'Switzernet';
  $Subject = 'New pending translations for website';
  $body = '';
  $body .= "Hello\n\n";
  $body .= "This is to inform your that new texts are pending for translation.\n";
  $body .= "For updating these translations, please go to http://switzernet.com".$_SERVER['REQUEST_URI'].".\n";
  $body .= "Here are the required texts to translate :\n\n";

  foreach ($NEW_TRANSLATION_TO_SEND as $value) {
    $body .= "[".$value."]\n";
  }

  $body .= "\n\n";
  $body .= "Best regards\n";
  $body .= "Note: This mail as been sent automaticaly\n";
  $body .= "\n";
  $mail->Body    = $body;
  $mail->Subject = $Subject;
  $mail->addAddress( 'nicolas.bondier@switzernet.com.test-google-a.com' );     // Add a recipient
  $mail->addAddress( 'elen.virabyan@intarnet.com' );     // Add a recipient
  $mail->send();
}

?>
</div>
</div>
  <script type="text/javascript" src="../js/maintainscroll.jquery.min.js"></script>
</body>
</html>
