<?php
  $Account->load_account_info();
?>
  <h2>
    <span id="choose-subscription">
    <?php  if ( ! $Account->account_info['IsPrepaidPrivate'] ){ ?>
      <?= l("Buy a subscription plan")?>
    <?php } elseif ( $Account->account_info['SubscriptionAutoRenewal'] == 0 && $Account->account_info['IsPrepaidPrivate'] ) { ?>
      <?= l("Extend my subscription plan")?>
    <?php } elseif ( $Account->account_info['SubscriptionAutoRenewal'] == 1 && $Account->account_info['IsPrepaidPrivate'] ) { ?>
      <?= l("Change my subscription plan")?>
    <?php } ?>
    </span>
  </h2>
  <div style="width:100%;padding-left:10px;padding-right:10px;margin-top:20px;overflow: auto;">
<?php
foreach ($SubscriptionPlans as $index => $sp) {
  if ( $index == 0 ) continue;
  $add_class = '';
  if ($Customer->customer_info['Active'] != 1  ){ 
    $add_class .= ' subscription-plan-deactivated ';
  } 
  if ( $index == $Account->account_info['CurrentSubscriptionType'] && $Account->account_info['SubscriptionAutoRenewal'] == 1 ){
    $add_class .= ' subscription-plan-selected ';
  }
?>
  <span class="subscription-plan <?= $add_class ?>" data-subscription-plan-id="<?= $index ?>" >
    <span class="subscription-plan-title"><?= $sp['Name'] ?></span>
    <span class="subscription-plan-subtitle"><?= $Customer->customer_info['Currency'] ?> <?= $sp['MonthlyFees'][$Customer->customer_info['Currency']] ?><?= l("/month")?></span>
    <?php if ( $sp['FreeDestinations'] ){ ?>
      <span class="subscription-plan-line"><?= l("- Free calls to 23 destinations.")?></span>
    <?php } else { ?>
      <span class="subscription-plan-line"><?= l("- Credit your account to call.")?></span>
      <span class="subscription-plan-line"><?= l("- No free destinations")?></span>
    <?php } ?>
    <?php if ( $sp['UnlimitedSimultaneousCalls'] ){ ?>
      <span class="subscription-plan-line"><?= l("- Unlimited simultaneous calls.")?></span>
    <?php } ?>
    <?php if ( $sp['RenewalPeriodMonths'] == 1 ){ ?>
      <span class="subscription-plan-line">- <?= $Customer->customer_info['Currency'] ?> <?= ( $sp['MonthlyFees'][$Customer->customer_info['Currency']] ) ?> <?= ( $Account->account_info['SubscriptionAutoRenewal'] == 1 ? l('every') : l('for').' 1 ' ) ?> <?= l("month")?>.</span>
    <?php } elseif ( $sp['RenewalPeriodMonths'] > 1 ) { ?>
      <span class="subscription-plan-line">- <?= $Customer->customer_info['Currency'] ?> <?= ( $sp['MonthlyFees'][$Customer->customer_info['Currency']] * $sp['RenewalPeriodMonths'] ) ?> <?= ( $Account->account_info['SubscriptionAutoRenewal'] == 1 ? l('every') : l('for') ) ?> <?= $sp['RenewalPeriodMonths'] ?> <?= l("months")?>.</span>
    <?php } ?>
  </span>

<?php } ?>
    <script type="text/javascript">
    // All same size
    $( document ).ready(function() {

      var maxHeight = Math.max.apply(null, $("span.subscription-plan").map(function () { return $(this).height(); }).get());
      var maxWidth = Math.max.apply(null, $("span.subscription-plan").map(function () { return $(this).width(); }).get());
      $("span.subscription-plan").height( Math.ceil(maxHeight) );
      $("span.subscription-plan").width( Math.ceil(maxWidth));
      //console.log(maxHeight+20);
      //console.log(maxWidth+20);
    });
    <?php if ($Customer->customer_info['Active'] == 1  ){ ?>
      $( "span.subscription-plan" ).click(function() {
        $( "span.subscription-plan" ).removeClass('subscription-plan-selected');
        $( this ).addClass('subscription-plan-selected');
        var id = $( this ).attr('data-subscription-plan-id');
        $( '#view_choose_new_subscription_plan' ).load('views/view_choose_new_subscription_plan.php?sp='+id);
        // Can be better. Like find maximum offset we can set ( target vs diff bettween document height and window height )
        if ( ( $(window).scrollTop() + $(window).height() ) < $(document).height() ){
          $('html, body').animate({
            scrollTop: ($("#choose-subscription").offset().top - 100)
          }, 1000);
        } else {
        // console.log("No scroll");
        }
        /*
          $('html, body').animate({
            scrollTop: ( $("#choose-subscription").offset().top - 100 )
          }, 1000);
        */
      });
    <?php } ?>


    $( document ).ready(function() {
      <?php
        if ( $Account->account_info['SubscriptionAutoRenewal'] == 1 ){
          echo '$( "#button-save-subscription-plan" ).removeClass("pure-button-disabled");';
        }
      ?>
    });

    </script>
  </div>
  
  <div class="view-text-container" id="view_choose_new_subscription_plan" ></div>
  <div class="view-text-container">
    <a href="#/prepaid_account/<?= $Account->account_info['ID'] ?>">
    <button id="button-save-subscription-plan" class="pure-button view-button pure-button-primary pure-button-disabled">
    <?php  if ( ! $Account->account_info['IsPrepaidPrivate'] ){ ?>
      <?= l("Buy this subscription plan")?>
    <?php } elseif ( $Account->account_info['SubscriptionAutoRenewal'] == 0 && $Account->account_info['IsPrepaidPrivate'] ) { ?>
      <?= l("Buy this subscription plan")?>
    <?php } elseif ( $Account->account_info['SubscriptionAutoRenewal'] == 1 && $Account->account_info['IsPrepaidPrivate'] ) { ?>
      <?= l("Save subscription plan")?>
    <?php } ?>
    </button></a>
    <script type="text/javascript">
      $( "#button-save-subscription-plan" ).click(function() {
        var sp = '';
        var tmp = $( "span.subscription-plan.subscription-plan-selected" );
        if ( tmp.length == 0 ){
          return false;
        }
        var id = $(tmp[0]).attr('data-subscription-plan-id');
        $( '#view_choose_new_subscription_plan' ).load('actions/update_subscription_plan.php?sp='+id);
        //$( '#view_change_subscription_plan' ).load('views/view_change_subscription_plan.php');
      });
    </script>
  <div class="view-text-container" id="update_subscription_plan" ></div>
</div>

