<?php

require_once RootDir.'etc/Devices.php';

?>
<script type="text/javascript">
$('document').ready(function() {
   $(window).scrollTop(0);
});

</script>

<?php if ( isset( $_GET['device'] ) && isset( $VoIPDevices[$_GET['device']] ) ){ ?>
  <form class="pure-form" name="DeviceOrder" id="DeviceOrder" method="post">
    <input type="hidden" value="<?= $_GET['device'] ?>">

<div class="content-section" style="" id="order_summary">
  <h2>
    <span><?= l("Your order")?></span>
  </h2>

<?php 

?>

  <table class="info_table">
    <tr>
      <td>
        <?= l("Device name")?>
      </td>
      <td>
        <?= $VoIPDevices[$_GET['device']]['NAME'] ?>
      </td>
    </tr>  
    <tr>
      <td>
        <?= l("Price")?>
      </td>
      <td>
        <?= number_format($VoIPDevices[$_GET['device']]['PRICE'][$Customer->customer_info['Currency']], 2) ?> <?= $Customer->customer_info['Currency'] ?>
      </td>
    </tr>  
    <tr>
      <td>
        <?= l("Shipping fees")?>
      </td>
      <td>
        <?php

        $ShippingFees = 0;
         if ( 
              strtolower($Customer->customer_info['Country']) == 'switzerland'
           || strtolower($Customer->customer_info['Country']) == 'suisse' 
           || strtolower($Customer->customer_info['Country']) == 'schweiz' 
           || strtolower($Customer->customer_info['Country']) == 'swiss' 
          ) { 
            $ShippingFees = $DeviceShippingFees['SWITZERLAND'][$Customer->customer_info['Currency']];
          } else {
            $ShippingFees = $DeviceShippingFees['INTERNATIONAL'][$Customer->customer_info['Currency']];
          }
       ?>
        <?= number_format($ShippingFees, 2) ?>  <?= $Customer->customer_info['Currency'] ?>
      </td>
    </tr>  
    <tr>
      <td>
        <?= l("Total order")?>
      </td>
      <td>
        <b> <?= number_format($VoIPDevices[$_GET['device']]['PRICE'][$Customer->customer_info['Currency']] + $ShippingFees, 2) ?> <?= $Customer->customer_info['Currency'] ?></b>
      </td>
    </tr>  
  </table>

  <h2>
    <span><?= l("Device pre-configuration")?></span>
  </h2>

  <table class="info_table">
    <tr>
      <td>
        <?= l("Configure with my account :")?>
      </td>
      <td>
        <select name="DeviceConfiguration[AccountID]" >
        <?php
          foreach ($Customer->customer_info['AccountsList'] as $number) {
            echo '<option value="'.$number.'">'.$number.'</option>';
          }
          echo '<option value="no">' . l("Do not configure") . '</option>';
        ?>
        </select>
      </td>
    </tr>  
  </table>
</div>

<div class="content-section" id="shipping_address">
  <h2>
    <span><?= l("Shipping address")?></span>
  </h2>
  <table class="info_table">
    <tr>
      <td><?= l("Firstname")?></td>
      <td><input name="ShippingAddress[Firstname]"  cols="17" type="text" value="<?= $Customer->customer_info['Firstname'] ?>"></td>
    </tr>
    <tr>
      <td><?= l("Lastname")?></td>
      <td><input name="ShippingAddress[Lastname]" cols="17" type="text" value="<?= $Customer->customer_info['Lastname'] ?>"></td>
    </tr>
    <tr>
      <td><?= l("Address")?></td>
      <td><textarea name="ShippingAddress[Address]" type="text" rows="2" cols="17" ><?= $Customer->customer_info['Address'] ?></textarea></td>
    </tr>
    <tr>
      <td><?= l("NPA")?></td>
      <td><input name="ShippingAddress[NPA]" cols="17" type="text" value="<?= $Customer->customer_info['NPA'] ?>"></td>
    </tr>
    <tr>
      <td><?= l("City")?></td>
      <td><input name="ShippingAddress[City]"  cols="17" type="text" value="<?= $Customer->customer_info['City'] ?>"></td>
    </tr>
    <tr>
      <td><?= l("Country")?></td>
      <td><input name="ShippingAddress[Country]"  cols="17" type="text" value="<?= $Customer->customer_info['Country'] ?>"></td>
    </tr>
  </table>

</div>
    <?php if (FALSE){ ?>

  <div class="content-section" id="order_payment">


  <h2>
    <span><?= l("Payment")?></span>
  </h2>

  <table class="info_table">
    <tr>
      <td>
        <?= l("Payment method")?>
      </td>
      <td>
        <select id="payment-method">
          <option value="balance"><?= l("Use my balance")?> (<?= number_format( $Customer->customer_info['Balance'] , 2)  ?> <?= $Customer->customer_info['Currency'] ?>)</option>
          <option value="checkout"><?= l("Pay manually (Checkout)")?></option>
        </select>
      </td>
    </tr>  
  </table>


</div>

  <?php } ?>

<div id="buy-message" class="content-section" style="width:100%">

</div>
<div style="/*width:100%;text-align: center;*/" class="content-section">
  
  <div class="view-text-container">
    <button type="button" id="return-to-shop" class="pure-button view-button"><?= l("Cancel")?></button>
    <button type="button" id="buy-button" class="pure-button view-button pure-button-primary"><?= l("Buy now")?></button>
  </div>
</div>

</form>

<?php } else { ?>
  <div class="alert-message">
    <?= l("Sorry. This device is not available.")?>
  </div>
  <div class="view-text-container">
    <button id="return-to-shop" class="pure-button view-button"><?= l("Return to devices")?></button>
  </div>
<?php } ?>
<script type="text/javascript">
  $( "#return-to-shop" ).click(function() {
    $( '#view_content' ).load('views/view_shop.php');
  });
  //$( "#payment-method" ).change(function() {
  //  $( '#view_content' ).load('views/view_shop.php');
  //});



  $( "#buy-button" ).click(function() {
    //console.log( $( "#payment-method" ).val() );
    $.post( 'actions/buy_device_with_balance.php?device=<?= $_GET['device'] ?>', $( "#DeviceOrder" ).serialize() , function( data,status ) {
      $( '#buy-message' ).html( data );
    }).fail(function(data){
      //console.log("failed");
    });

    /*
    if ( $( "#payment-method" ).val() == "balance" ){
      $.post( 'actions/buy_device_with_balance.php?device=<?= $_GET['device'] ?>', $( "#DeviceOrder" ).serialize() , function( data,status ) {
        $( '#buy-message' ).html( data );
      }).fail(function(data){
        //console.log("failed");
      });
    } else if (  $( "#payment-method" ).val() == "checkout" ){
      alert('checkout');
    }
    */
  });

</script>