<?php

$auto_renewal = false;


$ERROR = FALSE;
$ERROR_NAME = '';
$ERROR_TEXT = '';

if ( !$ERROR && ( $Customer->customer_info['AutomaticPaymentMethod'] != 'PayPal' && $Customer->customer_info['AutomaticPaymentMethod'] != 'MasterCard' && $Customer->customer_info['AutomaticPaymentMethod'] != 'VISA' ) ){
  $ERROR = TRUE;
  $ERROR_NAME = 'NO_AUTOMATIC_PAYMENT_METHOD';
  $Account->set_auto_renewal( false );
}

if ( !$ERROR && ( $Customer->customer_info['AutomaticPaymentMethod'] == 'PayPal' && $Customer->customer_info['AutomaticPaymentStatus'] != 'approved' )    ){
  $ERROR = TRUE;
  $ERROR_NAME = 'PAYPAL_NOT_APPROVED';
}

if ( !$ERROR && ( !isset($_GET['checked']) || ( $_GET['checked'] != 'true' && $_GET['checked'] != 'false' )  )    ){
  $ERROR = TRUE;
  $ERROR_NAME = 'UNKNOWN_ERROR';
}


/*
if ( !$ERROR && ( $Customer->customer_info['LastAutomaticPaymentStatus'] == 'Failed' )    ){
  $ERROR = TRUE;
  $ERROR_NAME = 'NO_AUTOMATIC_PAYMENT_METHOD';
}
*/

if ( $ERROR ){
  switch ($ERROR_NAME) {
    case "NO_AUTOMATIC_PAYMENT_METHOD":
      $ERROR_TEXT = l('You have not set an automatic payment method. Please add an automatic payment method in the').' <b><a href="#/billing" onclick="load_view(\'billing\');">' . l('Billing') . '</a></b> '.l('page first.');
      break;
    case "PAYPAL_NOT_APPROVED":
      $ERROR_TEXT = l('PayPal automatic payment is not approved. Please set a valid automatic payment method in the').' <b><a href="#/billing" onclick="load_view(\'billing\');">' . l('Billing') . '</a></b> '.l('page first.');
      break;
    case "UNKNOWN_ERROR":
      $ERROR_TEXT = l('An error occured. Please contact website administrator.');
      break;
  }
}

$Account->load_account_info();
if ( $ERROR ){
  $response = array(
    'SubscriptionAutoRenewal' => $Account->account_info['SubscriptionAutoRenewal'],
    'Error' => true,
    'ErrorMessage' => $ERROR_TEXT
  );
} else {
  if ( $_GET['checked'] == 'true' ){
    $auto_renewal = true;
  }
  $Account->set_auto_renewal( $auto_renewal );
  $Account->load_account_info();

  $response = array(
    'SubscriptionAutoRenewal' => $Account->account_info['SubscriptionAutoRenewal'],
    'Error' => false
  );
}

echo json_encode( $response );

?>
